<script setup>
</script>

<script>
import jQuery from "jquery";
import Jszip from 'jszip';
import DataTable from 'datatables.net-vue3';
import DataTableLib from 'datatables.net-bs5';
import 'datatables.net-buttons-bs5';
import 'datatables.net-buttons/js/buttons.html5.mjs';
import DataTableResponsive from "datatables.net-bs5";
import axios from 'axios';
import $ from 'jquery';
import swal from 'sweetalert';
import Multiselect from '@vueform/multiselect'
import '@vueform/multiselect/themes/default.css'
import { inject } from 'vue';

// Configurar JSZip
window.JSZip = Jszip;

// Inicializar DataTables con las bibliotecas
DataTable.use(DataTableLib);
DataTable.use(DataTableResponsive);



export default {
  components: { Multiselect },
  setup(props) {
	  const csrf = inject('csrf');
	
	  return {
	    csrf,
	  };
	},
  data() {
    return {
      products: null,
      InstitucionSancionadora: [],
	      OpcionesInstituciones: this.variables && this.variables.institucionesDependencias
	      ? this.variables.institucionesDependencias.map(item => item)
	      : [],

        institucionSeleccionada: null,
        usuariosDeInstitucion: [],

        usuariosSeleccionados: [],

        Usuarios: '',

        descripcion: '',

        url: '',

        usuariosIds: [],


        usuariosSeleccionadosPorInstitucion: [],

        

  
    }
  },

  mounted() {
    const csrf = inject('csrf');

  },

  props: {
	    variables: Object,
      
	},

  watch: {
        institucionSeleccionada(newInstitucion) {
      // Actualiza usuariosDeInstitucion con los usuarios de la institución seleccionada
      if (newInstitucion) {
        this.usuariosDeInstitucion = newInstitucion.usuarios;
      } else {
        this.usuariosDeInstitucion = [];
      }

      // Vacía usuariosSeleccionados cuando se cambia la institución seleccionada
      this.usuariosSeleccionados = [];
    },

    usuariosSeleccionados(newValue) {
      // Obtén los nuevos IDs seleccionados
      const selectedIds = newValue.map((option) => {
        const selectedOption = this.usuariosDeInstitucion.find(
          (sancion) => sancion.nombreCompleto === option
        );
        return selectedOption ? selectedOption.id : null;
      });

      // Actualiza usuariosIds con los nuevos IDs
      this.usuariosIds = selectedIds.filter(id => id !== null);
      console.log(this.usuariosIds)
    },
},

  methods: {
    
  }
}
</script>

<template>
  <div class="main-content">
    <div class="page-content">
      <div class="container-fluid">
        <div class="row">
          <div class="col-lg-12">
            <div class="card">
              <div class="card-body">
                <h4 class="card-title mb-4">Emision de notificacion</h4>
                <form method="POST" :action="route('notificaciones.store')">

                <div class="row">
                  <div class="col-md-3">
                    <div class="mb-3">
                      <label for="validationCustom04" class="form-label">Descripción</label>
                      <input name="descripcion" v-model="descripcion" type="text" class="form-control" id="validationCustom01" placeholder="Descripción"/> 
                    </div>
                  </div>
                  <div class="col-md-9">
                    <div class="mb-3">
                      <label for="validationCustom11" class="form-label">Institución dependencia</label>
                      <select v-model="institucionSeleccionada" class="form-select" id="validationCustom03" required>
                        <option v-for="opcion in OpcionesInstituciones" :value="opcion">{{ opcion.nombre }}</option>
                      </select>
                    </div>
                  </div>

                  <div class="col-md-12">
                    <div class="mb-3">
                      <label for="validationCustom14" class="form-label">Destinatario</label>
                      <Multiselect
                        v-model="usuariosSeleccionados"
                        ref="myMultiselect"
                        mode="tags"
                        :close-on-select="false"
                        :searchable="true"
                        placeholder="Seleccione una opción"
                        :options="usuariosDeInstitucion.map(option => option.nombreCompleto)"
                        class="tipoSancion"
                        required
                      />

                      <input type="hidden" hidden name="destinatarios" v-model="usuariosIds">                                                                               
                    
                    </div>
                  </div>

                  <div class="col-md-12">
                    <div class="mb-3">
                      <label for="exampleFormControlTextarea1">Detalle de la notificacion</label>
                      <textarea class="form-control" name="texto" rows="4"></textarea>                                        
                    </div>
                  </div>

                  <div class="col-md-12">
                    <div class="mb-3">
                      <label for="exampleFormControlTextarea1">Enlace a documento</label>
                      <input name="url" v-model="url" type="text" class="form-control" placeholder="Enlace a un documento"/> 
                    </div>
                  </div>

                  <div class="d-grid gap-2 d-md-flex justify-content-md-end">
                    <button class="btn btn-primary" type="submit">Notificar</button>
                  </div>
                </div>
                <input type="hidden" name="_token" :value="csrf"/>

              </form>

              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <footer class="footer"></footer>
  </div>
</template>

<style>
.dataTables_wrapper .dataTables_filter {
  margin-right: 10px;
}

.dataTables_filter{
  display: none;
}

#datatable-index-usuarios{
  margin-top: 10px;
}

.multiselect-tag{
  background: #6045ca;
}

.multiselect-wrapper {
    height: 10px;
    padding: .47rem 1.75rem .47rem .75rem;
    font-size: .8125rem;
}



.dt-buttons btn-group {
  background-color: red;
}

@media (min-width: 768px) {
  #TablaPrincipal_wrapper {}
}
</style>
